/*
Jaxe - Editeur XML en Java

Copyright (C) 2002 Observatoire de Paris-Meudon

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformment aux dispositions de la Licence Publique Gnrale GNU, telle que publie par la Free Software Foundation ; version 2 de la licence, ou encore ( votre choix) toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence Publique Gnrale GNU .

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

package jaxe.elements;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FileDialog;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;

import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.text.DefaultEditorKit;
import javax.swing.text.JTextComponent;

import jaxe.JaxeDocument;
import jaxe.JaxeResourceBundle;

import org.w3c.dom.DOMException;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;


public class DialogueFichier extends JDialog implements ActionListener, KeyListener {

    JComponent[] champs;
    String[] titres;
    boolean valide = false;
    Element defbalise;
    Element el;
    JFrame jframe;
    JaxeDocument doc;
    String srcAttr;
    
    public DialogueFichier(JFrame jframe, JaxeDocument doc, String titre, Element defbalise, Element el, String srcAttr) {
        super(jframe, titre, true);
        this.jframe = jframe;
        this.doc = doc;
        this.defbalise = defbalise;
        this.el = el;
        this.srcAttr = srcAttr;
        ArrayList latt = doc.cfg.listeAttributs(defbalise);
        int natt = latt.size();
        titres = new String[natt];
        champs = new JComponent[natt];
        for (int i=0; i<natt; i++) {
            Element att = (Element)latt.get(i);
            titres[i] = doc.cfg.nomAttribut(att);
            String elval = el.getAttribute(titres[i]);
            String[] lval = doc.cfg.listeValeurs(att);
            if (lval != null && lval.length > 0) {
                JComboBox popup = new JComboBox();
                champs[i] = popup;
                if (!doc.cfg.estObligatoire(att))
                    popup.addItem("");
                for (int j=0; j<lval.length; j++) {
                    String sval = lval[j];
                    popup.addItem(sval);
                    if (sval.equals(elval))
                        popup.setSelectedItem(sval);
                }
            } else
                champs[i] = new JTextField(elval, 40);
        }
        JPanel cpane = new JPanel(new BorderLayout());
        setContentPane(cpane);
        JPanel chpane = new JPanel(new BorderLayout());
        JPanel qpane = new JPanel(new GridLayout(titres.length, 1));
        for (int i=0; i<titres.length; i++) {
            JLabel label = new JLabel(titres[i]);
            Element att = (Element)latt.get(i);
            if (doc.cfg.estObligatoire(att))
                label.setForeground(new Color(150, 0, 0)); // rouge fonc
            else
                label.setForeground(new Color(0, 100, 0)); // vert fonc
            qpane.add(label);
        }
        qpane.setBorder(BorderFactory.createEmptyBorder(0, 5, 0, 5));
        JPanel tfpane = new JPanel(new GridLayout(champs.length, 1));
        for (int i=0; i<champs.length; i++) {
            tfpane.add(champs[i]);
        }
        chpane.add(qpane, BorderLayout.CENTER);
        chpane.add(tfpane, BorderLayout.EAST);
        cpane.add(chpane, BorderLayout.CENTER);
        
        JPanel bpane0 = new JPanel(new GridLayout(2, 1));
        
        JPanel bpane1 = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        JButton boutonSelectionner = new JButton(JaxeResourceBundle.getRB().getString("fichier.Selectionner"));
        boutonSelectionner.addActionListener(this);
        boutonSelectionner.setActionCommand("Slectionner");
        bpane1.add(boutonSelectionner);
        if (doc.fsave != null) {
            JButton boutonCopier = new JButton(JaxeResourceBundle.getRB().getString("fichier.Copier"));
            boutonCopier.addActionListener(this);
            boutonCopier.setActionCommand("Copier");
            bpane1.add(boutonCopier);
        }
        bpane0.add(bpane1);

        JPanel bpane2 = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        JButton boutonAnnuler = new JButton(JaxeResourceBundle.getRB().getString("bouton.Annuler"));
        boutonAnnuler.addActionListener(this);
        boutonAnnuler.setActionCommand("Annuler");
        bpane2.add(boutonAnnuler);
        JButton boutonOK = new JButton(JaxeResourceBundle.getRB().getString("bouton.OK"));
        boutonOK.addActionListener(this);
        boutonOK.setActionCommand("OK");
        bpane2.add(boutonOK);
        bpane0.add(bpane2);
        
        cpane.add(bpane0, BorderLayout.SOUTH);
        getRootPane().setDefaultButton(boutonOK);
        
        cpane.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        JTextField atf = null;
        for (int i=0; i<natt; i++)
            if (champs[i] instanceof JTextField)
                atf = (JTextField)champs[i];
        if (atf != null) {
            createActionTable(atf);
            //addMenus();
        }
        addKeyListener(this);
        pack();
        addWindowListener(new WindowAdapter() {
            boolean gotFocus = false;
            public void windowActivated(WindowEvent we) {
                // Once window gets focus, set initial focus
                if (!gotFocus) {
                    champs[0].requestFocus();
                    gotFocus = true;
                }
            }
        });
        Rectangle r = jframe.getBounds();
        setLocation(r.x + r.width/4, r.y + r.height/4);
    }
    
    Hashtable actions;
    private void createActionTable(JTextComponent textComponent) {
        actions = new Hashtable();
        Action[] actionsArray = textComponent.getActions();
        for (int i = 0; i < actionsArray.length; i++) {
            Action a = actionsArray[i];
            actions.put(a.getValue(Action.NAME), a);
        }
    }
    private Action getActionByName(String name) {
        return (Action)(actions.get(name));
    }

    public void keyPressed(KeyEvent e) {
        if (e.isMetaDown()/* || e.isControlDown()*/) {
            //System.out.println("cmd-"+e.getKeyChar());
            int modifiers = 0;
            if (e.isMetaDown())
                modifiers = ActionEvent.META_MASK;
            if ('C' == e.getKeyChar()) {
                //if (e.isControlDown())
                //    modifiers = ActionEvent.CTRL_MASK;
                ActionEvent ae = new ActionEvent(this, ActionEvent.ACTION_PERFORMED, "copy", modifiers);
                getActionByName(DefaultEditorKit.copyAction).actionPerformed(ae);
            }
            if ('X' == e.getKeyChar()) {
                ActionEvent ae = new ActionEvent(this, ActionEvent.ACTION_PERFORMED, "cut", modifiers);
                getActionByName(DefaultEditorKit.cutAction).actionPerformed(ae);
            }
            if ('V' == e.getKeyChar()) {
                ActionEvent ae = new ActionEvent(this, ActionEvent.ACTION_PERFORMED, "paste", modifiers);
                getActionByName(DefaultEditorKit.pasteAction).actionPerformed(ae);
            }
        }
    }
    
    public void keyReleased(KeyEvent e) {
    }
    
    public void keyTyped(KeyEvent e) {
    }
    
    public boolean afficher() {
        show();
        return(valide);
    }

    public String[] lireReponses() {
        String[] rep = new String[champs.length];
        for (int i=0; i<champs.length; i++) {
            if (champs[i] instanceof JTextComponent)
                rep[i] = ((JTextComponent)champs[i]).getText();
            else if (champs[i] instanceof JComboBox)
                rep[i] = (String)((JComboBox)champs[i]).getSelectedItem();
            else
                rep[i] = null;
        }
        return(rep);
    }
    
    public void enregistrerReponses() {
        String[] rep = lireReponses();
        try {
            for (int i=0; i<rep.length; i++) {
                if ("".equals(rep[i]) && !"".equals(el.getAttribute(titres[i])))
                    el.removeAttribute(titres[i]);
                else if (rep[i] != null && (!"".equals(rep[i])))
                    el.setAttribute(titres[i], rep[i]);
            }
            doc.modif = true;
        } catch (DOMException ex) {
            System.err.println("DOMException: " + ex.getMessage());
            return;
        }
    }
    
    protected boolean checkAtt() {
        String[] rep = lireReponses();
        NodeList latt = defbalise.getElementsByTagName("ATTRIBUT");
        int natt = latt.getLength();
        for (int i=0; i<natt; i++) {
            Element att = (Element)latt.item(i);
            String presence = att.getAttribute("presence");
            if ("obligatoire".equals(presence) && (rep[i] == null ||
                "".equals(rep[i]))) {
                getToolkit().beep();
                if (champs[i] instanceof JTextComponent)
                    ((JTextComponent)champs[i]).selectAll();
                return false;
            }
        }
        return true;
    }
    
    public void setNomFichier(String nom) {
        for (int i=0; i<titres.length; i++)
            if (srcAttr.equals(titres[i]))
                ((JTextComponent)champs[i]).setText(nom);
    }
    
    /**
     * Mthode spcifique au schma du projet ASM ( modifier...)
     */
    public void setType(String nomf) {
        if (!"FICHIER".equals(doc.cfg.nomBalise(defbalise)))
            return;
        int ip = nomf.lastIndexOf('.');
        if (ip == -1)
            return;
        String ext = nomf.substring(ip + 1);
        String stype = null;
        if ("gif".equals(ext))
            stype = "gif";
        else if ("jpeg".equals(ext) || "jpg".equals(ext))
            stype = "jpeg";
        else if ("png".equals(ext))
            stype = "png";
        else if ("mpeg".equals(ext) || "mpg".equals(ext))
            stype = "mpeg";
        else if ("mng".equals(ext))
            stype = "mng";
        else if ("text".equals(ext) || "txt".equals(ext))
            stype = "texte";
        else if ("html".equals(ext) || "htm".equals(ext))
            stype = "html";
        if (stype == null)
            return;
        for (int i=0; i<titres.length; i++)
            if ("type".equals(titres[i])) // spcifique  un schma :(
                ((JComboBox)champs[i]).setSelectedItem(stype);
    }
    /*
    public void addFilters(FileDialog fd/JFileChooser chooser) {
        //utile avec JFileChooser
        String[] htmlFilters = {"html", "htm"};
        chooser.addChoosableFileFilter(new ExampleFileFilter(htmlFilters, "html"));
        String[] textFilters = {"text", "txt"};
        chooser.addChoosableFileFilter(new ExampleFileFilter(textFilters, "texte"));
        String[] mpegFilters = {"mpeg", "mpg"};
        chooser.addChoosableFileFilter(new ExampleFileFilter(mpegFilters, "mpeg"));
        chooser.addChoosableFileFilter(new ExampleFileFilter("png"));
        String[] jpegFilters = {"jpeg", "jpg"};
        chooser.addChoosableFileFilter(new ExampleFileFilter(jpegFilters, "jpeg"));
        chooser.addChoosableFileFilter(new ExampleFileFilter("gif"));
        chooser.setAcceptAllFileFilterUsed(true); // pour mettre *.* par dfaut
        
        //utile avec FileDialog:
        String[] filters = new String[10];
        filters[0] = "gif";
        filters[1] = "jpeg";
        filters[2] = "jpg";
        filters[3] = "png";
        filters[4] = "mpeg";
        filters[5] = "mpg";
        filters[6] = "text";
        filters[7] = "txt";
        filters[8] = "html";
        filters[9] = "htm";
        fd.setFilenameFilter(new ExtFilter(filters));
    }
    */
    protected String cheminURI(File f) {
        String spath = f.getPath();
        boolean abso = f.isAbsolute();
        if (abso) {
            if (doc.fsave != null) {
                String chemin1 = doc.fsave.getParent();
                if (spath.startsWith(chemin1)) {
                    spath = spath.substring(chemin1.length()+1); // chemin relatif / fichier XML
                    abso = false;
                }
            }
        }
        if (!abso && File.separatorChar != '/') {
            // sur Windows, on transforme les \ en /
            spath = spath.replace(File.separatorChar, '/');
            
            // commment faire si le chemin est absolu ?
        }
        return(spath);
    }
    
    public void selectionnerFichier() {
        /*
        JFileChooser chooser;
        if (doc.fsave != null)
            chooser = new JFileChooser(doc.fsave.getParentFile());
        else
            chooser = new JFileChooser();
        addFilters(chooser);
	int returnVal = chooser.showOpenDialog(this);
	if(returnVal == JFileChooser.APPROVE_OPTION) {
            File theFile = chooser.getSelectedFile();
        */
        FileDialog fd = new FileDialog(jframe);
        if (doc.fsave != null)
            fd.setDirectory(doc.fsave.getParent());
        fd.show();
        String sf = fd.getFile();
        if (sf != null) {
            File theFile = new File(fd.getDirectory(), sf);
            setNomFichier(cheminURI(theFile));
            setType(theFile.getName());
        }
    }
    
    public void copierFichier() {
        /*
        JFileChooser chooser;
        if (doc.fsave != null)
            chooser = new JFileChooser(doc.fsave.getParentFile());
        else
            chooser = new JFileChooser();
        addFilters(chooser);
	int returnVal = chooser.showOpenDialog(this);
	if(returnVal == JFileChooser.APPROVE_OPTION) {
            File theFile = chooser.getSelectedFile();
        */
        FileDialog fd = new FileDialog(jframe);
        fd.show();
        String sf = fd.getFile();
        if (sf != null) {
            File theFile = new File(fd.getDirectory(), sf);
            copierFichier(theFile, doc.fsave.getParent() + File.separator + theFile.getName());
            setNomFichier(theFile.getName());
            setType(theFile.getName());
        }
    }
    
    public void copierFichier(File inputFile, String nomf2) {
        File outputFile = new File(nomf2);
        
        try {
            int bufSize = 1024; 
            BufferedInputStream in  = new BufferedInputStream( 
                                        new FileInputStream(inputFile),bufSize); 
            BufferedOutputStream out = new BufferedOutputStream( 
                                        new FileOutputStream(outputFile), bufSize); 
            int length = 32;  
            byte[] ch = new byte[length]; 
            while((length = in.read(ch))!= -1) { 
                out.write(ch,0,length); 
            } 
            out.flush(); 
            in.close(); 
            out.close(); 
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(this, ex.getMessage(),
                "IOException", JOptionPane.ERROR_MESSAGE);
        }
    }
    
    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        if ("OK".equals(cmd)) {
            if (checkAtt()) {
                valide = true;
                setVisible(false);
            }
        } else if ("Annuler".equals(cmd)) {
            valide = false;
            setVisible(false);
        } else if ("Slectionner".equals(cmd)) {
            selectionnerFichier();
        } else if ("Copier".equals(cmd)) {
            copierFichier();
        }
    }

}
