/*
Jaxe - Editeur XML en Java

Copyright (C) 2002 Observatoire de Paris-Meudon

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformment aux dispositions de la Licence Publique Gnrale GNU, telle que publie par la Free Software Foundation ; version 2 de la licence, ou encore ( votre choix) toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence Publique Gnrale GNU .

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

package jaxe.elements;

import jaxe.JaxeDocument;

import org.w3c.dom.DOMException;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

/**
 * Fichier d'image comme Fichier, mais que l'on peut crer avec un dialogue affichant les images
 * se trouvant dans le dossier 'symboles' de Jaxe.
 * Type d'lment Jaxe: 'symbole'
 */
public class JESymbole extends JEFichier {

    public JESymbole(JaxeDocument doc) {
        super(doc);
    }

    public Node nouvelElement(Element defbalise) {
        String nombalise = doc.cfg.nomBalise(defbalise);
        
        String srcAttr = defbalise.getAttribute("param");
        if (srcAttr.equals(""))
            srcAttr = defaultSrcAttr;
        srcAttr = doc.cfg.getParamFromDefinition(defbalise, "srcAtt", srcAttr);
        
        Element newel = nouvelElementDOM(doc, defbalise);
        
        DialogueSymbole dlg = new DialogueSymbole(doc.jframe, newel);
        if (!dlg.afficher())
            return null;
        String sf = dlg.fichierChoisi();
        
        try {
            newel.setAttribute(srcAttr, sf);
            if ("FICHIER".equals(nombalise)) { // spcifique aux schmas ASM :(
                int ip = sf.lastIndexOf('.');
                if (ip != -1) {
                    String ext = sf.substring(ip+1).toLowerCase();
                    if ("png".equals(ext) || "gif".equals(ext))
                        newel.setAttribute("type", ext);
                }
            }
        } catch (DOMException ex) {
            System.err.println("DOMException: " + ex.getMessage());
            return null;
        }

        return(newel);
    }
}
